﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class Personagem : MonoBehaviour {
	float Vx; 	//velocidade em x
	float Vy;	//velocidade em y
	float VelocidadeHorizontal;
	float VelocidadePular;
	float DirecaoHorizontal; //variavel que armazena a direção: para esquerda, para a direita ou parado
	Rigidbody2D CorpoRigido; //corpo rígido do elemento onde o script foi inserido.
	BoxCollider2D Colisor; // colisor do elemento onde o script foi inserido.
	float ContadorPulos;


	void Start () {
		ContadorPulos = 0;
		VelocidadeHorizontal = 5;	//incia a velocidade de andar na horizontal(direita e esquerda)
		VelocidadePular	= 5;		//inicia a velocidade de pular
		CorpoRigido = GetComponent<Rigidbody2D> ();		//recupera o corpo rigido inserido no elemento que possui o script(corpo rígido do personagem)
		Colisor = GetComponent<BoxCollider2D> (); 	//recupera o colisor inserido no elemento que possui o script(colisor do personagem)	
		CorpoRigido.freezeRotation = true;				//impede que rotacione no eixo.	
	}


	void Update () {
		MovimentoHorizontal();
		PuloDuplo();
	}
	void PuloDuplo(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");
		// esse bloco só é executado se for apertado o botão de Jump
		// e se o personagem ContadorPulos < 2
		if (apertou == true &&  ContadorPulos < 2 ) {
			ContadorPulos = ContadorPulos+1;
			VelocidadeHorizontal = VelocidadeHorizontal / 2;
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}

	void MovimentoHorizontal(){
		//DirecaoHorizontal Recebe até 1 quando precionado o botão para direita e até -1 para esquerda. Quando parado Recebe 0.
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		// Gera uma nova velocidade em x
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		 //Recupera a velocidade em y que o personagem já possui
		Vy = CorpoRigido.velocity.y;
		//Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		Vector2 andar = new Vector2 (Vx, Vy);
		// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
		CorpoRigido.velocity = andar;
	}

	void OnCollisionEnter2D(Collision2D objetoTocado){
		string tagTocada = objetoTocado.gameObject.tag;
		if (tagTocada == "chao") {
			ContadorPulos = 0;
			VelocidadeHorizontal = 5;
		}
	}
}
